#include "draw.h"

void drawCircle(IplImage* src, int xo, int yo, double r) {

  int x,y;
  char pix[3]={255,255,255};

  int p= static_cast<int>(r/sqrt(2.) + 1.);

  for (x=0; x<=p; x++) {

    y= static_cast<int>(sqrt(r*r - x*x) + 0.5);

    iplPutPixel(src, xo+x , yo+y, &pix);
    iplPutPixel(src, xo-x , yo+y, &pix);
    iplPutPixel(src, xo+x , yo-y, &pix);
    iplPutPixel(src, xo-x , yo-y, &pix);

    iplPutPixel(src, yo+y, xo+x, &pix);
    iplPutPixel(src, yo+y, xo-x, &pix);
    iplPutPixel(src, yo-y, xo+x, &pix);
    iplPutPixel(src, yo-y, xo-x, &pix);
  }
}

void drawLine(IplImage* src, int xo, int yo, int xf, int yf) {

  char pix[3]={255,255,255};
  double slope= ((double)(yf-yo))/((double)(xf-xo));

  if (fabs(slope) < 1.0) {

    int dx= (xf < xo) ? -1 : 1;
    int x;
    double y;
    double dy= (yf < yo) ? -fabs(slope) : fabs(slope);

    for (x=xo, y=yo; x!=xf; x+= dx) {

      y+= dy; 
      iplPutPixel(src, x, static_cast<int>(y), &pix);

    }

  } else {

    int dy= (yf < yo) ? -1 : 1;
    int y;
    double x;
    double dx= (xf < xo) ? -fabs(1./slope) : fabs(1./slope);

    for (x=xo, y=yo; y!=yf; y+= dy) {

      x+= dx; 
      iplPutPixel(src, static_cast<int>(x), y, &pix);

    }
  }
}
