// junctionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "junction.h"
#include "junctionDlg.h"
#include "judoca.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJunctionDlg dialog

CJunctionDlg::CJunctionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJunctionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJunctionDlg)
	m_variance = 0.0f;
	m_edgeth = 0;
	m_radius = 0;
	m_percentage = 0.0f;
	m_dispradius = 0;
	m_maxang = 0.0f;
	m_njmax = 0;
	m_minang = 0.0f;
	m_nmaxr = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CJunctionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJunctionDlg)
	DDX_Text(pDX, IDC_EDIT1, m_variance);
	DDV_MinMaxFloat(pDX, m_variance, 0.f, 1.e+007f);
	DDX_Text(pDX, IDC_EDIT2, m_edgeth);
	DDV_MinMaxUInt(pDX, m_edgeth, 0, 255);
	DDX_Text(pDX, IDC_EDIT3, m_radius);
	DDV_MinMaxInt(pDX, m_radius, 0, 100);
	DDX_Text(pDX, IDC_EDIT4, m_percentage);
	DDV_MinMaxFloat(pDX, m_percentage, 0.f, 1.f);
	DDX_Text(pDX, IDC_EDIT5, m_dispradius);
	DDV_MinMaxInt(pDX, m_dispradius, 0, 200);
	DDX_Text(pDX, IDC_EDIT6, m_maxang);
	DDX_Text(pDX, IDC_EDIT7, m_njmax);
	DDX_Text(pDX, IDC_EDIT8, m_minang);
	DDX_Text(pDX, IDC_EDIT9, m_nmaxr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJunctionDlg, CDialog)
	//{{AFX_MSG_MAP(CJunctionDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnJunction)
	ON_BN_CLICKED(IDC_BUTTON3, OnSave)
	ON_BN_CLICKED(IDC_BUTTON4, OnSuppress)
	ON_BN_CLICKED(IDC_BUTTON5, OnLoad)
	ON_BN_CLICKED(IDC_BUTTON6, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJunctionDlg message handlers

BOOL CJunctionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

    judoca= 0;
    m_variance= 1.0;
    m_edgeth= 10;
    m_percentage= 0.8f;
    m_radius= 10;
    m_dispradius= 10;
	m_maxang= 140.; 
	m_minang= 40.; 
	m_njmax= 0.; 
    m_nmaxr= 1;
    UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJunctionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJunctionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJunctionDlg::OnOpen() 
{
  CFileDialog dlg(TRUE, _T("*.bmp"), "", 
                  OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
                  "image files (*.bmp; *.jpg) |*.bmp;*.jpg|All Files (*.*)|*.*||",NULL);

  char title[]= {"Open Image"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) {

    CString path= dlg.GetPathName();

    delete judoca;

    judoca= new Judoca(path);
  }	
}

void CJunctionDlg::OnJunction() 
{
  if (judoca == 0)
    OnOpen();
 
  UpdateData(true);
  judoca->detect(m_variance,m_edgeth,m_radius,m_percentage,m_minang,m_maxang);
  
  if (m_njmax<1) m_njmax= 0;

  judoca->display(m_dispradius, m_njmax);

}

void CJunctionDlg::OnOK() 
{
    delete judoca;	
	CDialog::OnOK();
}

void CJunctionDlg::OnSave() 
{
  CFileDialog dlg(FALSE, _T(".jun"), "", 
                  OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY,
                  "junction files (*.jun) |*.jun|image files (*.bmp; *.jpg) |*.bmp;*.jpg|All Files (*.*)|*.*||",NULL);

  char title[]= {"Save Junctions"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) {

    CString path= dlg.GetPathName();

    judoca->save(path);
  }	
	
}

void CJunctionDlg::OnSuppress() 
{
  UpdateData(true);

  judoca->suppress(m_nmaxr);	

  if (m_njmax<1) m_njmax= 0;

  judoca->display(m_dispradius, m_njmax);
}

void CJunctionDlg::OnLoad() 
{
  CFileDialog dlg(TRUE, _T("*.bmp"), "", 
                  OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
                  "junction files (*.jun) |*.*||",NULL);

  char title[]= {"Open Junction File"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) {

    CString path= dlg.GetPathName();

	UpdateData(true);

    judoca->load(path);
	judoca->display(m_dispradius, m_njmax);
  }		
}

void CJunctionDlg::OnCancel() 
{
	OnOK();	
}
